{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+}
{$M 28000,0,60000}

program Vyled; {marek laco januar/ferbuar 1997}

uses spx_vga,G_modes,MLkbd,MLdos,MLtxt,MLgrf,txt,Mouse,Dos,Graph,Crt,FNTmarek;


       const NazovDna: array[0..6] of string = ('Nedela', 'Pondelok',
                                                'Utorok', 'Streda',
                                                'Stvrtok', 'Piatok', 'Sobota');

       const ANO_NIE_Str = 'ANO-[A,Y,ENTER]      Nie-[N,ESC]';


       type _Datum = record
                       Rok, Mesiac, Den: word;
                     end;

       type _Info = record
                      FileHead: string[100];
                      T_Pocet, P_Pocet: longint;
                      CasVzniku: DateTime;
                      CasVyletu: _Datum;
                      Km: word;
                      Popis: string[20];
                      Text: string[200];
                      Pozadie: string[12];
                    end;

       type _trasa = record
                       X1, X2: _X;
                       Y1, Y2: _Y;
                       Farba: byte;
                     end;

       type _poznam = record
                        X1: _X;
                        Y1: _Y;
                        Farba: byte;
                        Text: string[50];
                        Cislo: longint;
                      end;



var

   i, j, k: longint;
  ch: char;

          Speed: word;
     X, Y, Tlac: integer;
     OldX, OldY: integer;
     MaxX, MaxY: integer;
     PomX, PomY: longint;

         F_Size: longint;
         F_Name: string;
          F_Ext: string;
    Prog_F_Name: string;

  Color, CColor: byte;
     SavedColor: array[1..10] of byte;

       Podlozka: pointer;
  Size, PodSize: word;  {Size - velkost pre pointer, PodSize - velkost pre
                             pozadie}
           Draw: boolean;
          Saved: boolean;
        Skoncit: boolean;
      BoloShift: boolean;
    LupaVisible: boolean;
  PaletaVisible: boolean;
          Trasa: array[1..5000] of _Trasa;
         Poznam: array[1..50] of _Poznam;

        T_Cislo: word;
        P_Cislo: byte;
             Km: word;
          Popis: string[20];
           Text: string[200];
        Pozadie: string[12];
      CasVzniku: DateTime;
      CasVyletu: _Datum;

    ProgDescrib: string;
          Autor: string;
       SerCislo: string;
          Owner: string;


          Rok, Mesiac, Den, CDna, Hod, Minuta, PomWord: word;





{stara procedure - historia}
{
procedure Kresli;
var Subor: file of _trasa; Trasa: _Trasa; SuborName: string; X1, Y1, X2, Y2, I, J, q: integer;
color: integer; _I: byte;
begin
  SetColor(10);
  SetLineStyle(0, 0, 3);

  SuborName := 'SLOV96.DAT';
  if not fileExist(suborname) then abord('njeje: ' + suborname);
  Assign(Subor, SuborName);
  repeat
    for _I := 1 to 1 do
      begin
        SetColor(11);
        if _I = 2 then SetColor(0);
        Reset(Subor);
        read(subor, trasa);


        x1 := trasa.x;
        y1 := trasa.y;
        while not Eof(Subor) do
          begin
            read(subor, trasa);
            x2 := trasa.x;
            y2 := trasa.y;
            Line(X1, Y1 - 10, X2, Y2 - 10);
            if _I = 1 then Delay(40);
            if (keypressed = 1) and (readkey=#27) then Skonci;
            x1 := x2;
            y1 := y2;
         end;
    end;
  until FALSE; keypressed;
  Close(Subor);
  Readkey;
  CloseGraph;
end;
}

procedure VlozKontrolneBody;
begin
  {napise body, ak sa zmazu, tak obrazok bol nacitany.}
  PutPixel(500, 0, 0);
  PutPixel(501, 100, 1);
  PutPixel(502, 100, 2);
  PutPixel(503, 100, 3);
  PutPixel(504, 100, 4);
end;

procedure SkontrolujKontrolneBody;
var A: array[0..4] of byte; I, B: word;
begin
  {ak kontrolne body budu ako predty, tak obrazok sa nanacital ==> malo pamete}
  B := 0; {kontrola}
  for I := 0  to 4 do A[i] := GetPixel(500 + i, 100);
  for I := 0 to 4 do if A[i] = i then Inc(B);
  if (B = 5) and (ALT = FALSE) then
    Abord('malo zakladnej pamete, treba uvolnit viacej, potom uvidim...');
end;


function InaFarba(C: byte): byte; {aby logo bolo v dobrych farbach}
begin
  case C of
    0: Inafarba := 0;
    1: Inafarba := 255;
    2: Inafarba := 179;
    3: Inafarba := 255;
    else Inafarba := 255;
  end;
end;

procedure Logo(X, Y: Integer);
const
 MaxX = 60;
 MaxY = 40;
type
 _Farby = 0..3;
 _Pole = array[1..MaxX, 1..MaxY] of _Farby;
var
 Pole: _Pole;
 F_name: string;
 Subor: file of _Pole;
 I, J: integer;
begin
 F_Name := 'VYLED_A.DAT';
 {$I-}
 Assign(Subor, F_Name);
 Reset(Subor);
 Read(Subor, Pole);
 Close(Subor);
 {$I-}
 if IOresult <> 0 then
  begin
   CloseGraph;
   Writeln(F_Name, ' - nenesiel som!');
   Halt(255);
  end;
 for I := 1 to MaxX do for J := 1 to MaxY do
  PutPixel(X + I - 1, Y + J - 1, InaFarba(Pole[I, J]));
end;




procedure Stempel(X, Y: Integer);
const
 MaxX = 60;
 MaxY = 40;
type
 _Farby = 0..3;
 _Pole = array[1..MaxX, 1..MaxY] of _Farby;
var
 Pole: _Pole;
 Subor: file of _Pole;
 I, J: integer;
 F_Name: string;
begin
 F_Name := 'VYLED_B.DAT';
 {$I-}
 Assign(Subor, F_Name);
 Reset(Subor);
 Read(Subor, Pole);
 Close(Subor);
 {$I-}
 if IOresult <> 0 then
  begin
   Closegraph;
   Writeln(F_Name, ' - nenesiel som!');
   Halt(255);
  end;
 for I := 1 to MaxX do for J := 1 to MaxY do
  PutPixel(X + I - 1, Y + J - 1, InaFarba(Pole[I, J]));
end;


function CitajText(X: _X; Y: _Y; Color: byte): string;
var St, PomSt: string;
  I, J, Poc: word;
    Ch, OldCh: char;
   CRs: byte;
    pX: _X;
    pY: _Y;

  procedure KurZ;
  begin
    if Poc < 1000 then
      begin
        SetColor(Color);
        OutTextXY(pX, pY, #219);

      end;

    if Poc > 1000 then
      begin
        SetColor(0);
        OutTextXY(pX, pY, #219);
        if Poc > 2000 then Poc := 0;
      end;
  end;
Label Lab;
begin
  St := '';
  PomSt := '';
  CRs := 0;
  Poc := 0;
  Ch := #0;
  OldCh := Ch;
  repeat
    Lab:
    Inc(Poc);
    pX := X + TextWidth(PomSt);
    pY := Y + CRs * (TextHeight(St) + 1);
    KurZ;
    if KeyPressed then
      begin
        Poc := 2001;
        KurZ;
        Ch := ReadKey;
        if (Ch <> #27) then
          begin
            if Ch = #8 then {BS}
              begin
                if St[Length(St)] <> #13 then
                  begin
                    Delete(St, Length(St), 1);
                    Delete(PomSt, Length(PomSt), 1);
                    {--- nasledujuce 3 riadky su nepotrebne---}
                    { pokym je kurzor velky ako cele pismeno !}
                    SetColor(0);
                    OldCh := PomSt[Length(St) + 1];
                    OutTextXY(pX - TextWidth(OldCh), pY, OldCh);
                  end;
                Goto Lab;
              end
            else
             begin
               St := St + Ch;
               PomSt := PomSt + Ch;
             end;
          end;
        SetColor(Color);
        OutTextXY(pX, pY, Ch);
        if pX > (GetMaxX - 10) then
          begin
            St := St + #13;
            Inc(CRs);
            PomSt := '';
          end;
        if Ch = #13 then
          begin
            Inc(CRs);
            PomSt := '';
          end;
      end;
  until Ch = #27;
  CitajText := St;
end;



function CitajText2(X: _X; Y: _Y; Color: byte; Sprava: string): string;
const Speed = 2000;  {rychlost kurzora}
var St, PomSt: string;
  I, J, Pos: word;
   Poc: word;
    Ch, OldCh: char;
    KurzX, pX, ppx: _X;
    pY, ppy: _Y;

  procedure KurZ;
  var Ch: char;
  begin
    pX := X - ppx;
    py := Y + ppy;
    KurzX := X - ppx + TextWidth(Copy(St, 1, Pos - 1));
    if Pos > Length(St) then Ch := St[Pos - 1]
     else Ch := St[Pos];
    if Poc = 1 then
      begin
        Vymaz(KurzX, pY, KurzX + TextWidth(Ch) - 1, pY + TextHeight(Ch), Color);
      end;
    if Poc = Speed + 1 then
      begin
        if Pos > Length(St) then Ch := #32
         else Ch := St[Pos];
        Vymaz(KurzX, pY, KurzX + TextWidth(Ch) - 1, pY + TextHeight(Ch), 0);
        SetColor(Color);
        OutTextXY(KurzX, pY, Ch);
      end;
    if Poc > (Speed * 2) then Poc := 0;
  end;

  procedure Napis;
  begin
    pX := X - ppx;
    py := Y + ppy;
    Vymaz(pX, pY, pX + TextWidth(St) + 2 * TextWidth(St[Pos]), pY + TextHeight(St), 0);
    SetColor(Color);
    OutTextXY(pX, pY, St);
  end;

begin
  St := Sprava;
  Poc := 0;  {pre kurzor}
  Ch := #0;
  OldCh := Ch;
  Pos := Length(St) + 1; {pozicia kurzora v stringu}
  ppx := 0;
  ppy := 0;
  Napis;
  repeat
    Inc(Poc);
    KurZ;
    if KeyPressed then
      begin
        Ch := ReadKey;
        if Ch = #0 then
          begin
            Ch := UpCase(Readkey);
            case Klavesa(Ch) of
              4: if Pos > 1 then Dec(Pos);  {vlavo}
              6: if Pos <= Length(St) then Inc(Pos); {vpravo}
              7, 8: Pos := 1;  {Home, hore}
              1, 2: Pos := Length(St) + 1; {End, dole}
              11: begin {Delete}
                    Delete(St, Pos, 1)
                  end;
            end;
          end
         else
          begin
            if (Ch <> #27) then
              begin
                case Ch of
                 #09: begin  {tab}
                        if Pos < Length(St) - 7 then Inc(Pos, 6)
                         else Pos := Length(St) + 1;
                      end;
                 #25: begin
                        J := Length(St);
                        St := '';
                        for I := 1 to J do St := St + ' ';
                        Napis; {vymaz}
                        St := '';
                        Pos := 1;
                      end;
                 #08: begin  {BS}
                        if Pos > 1 then
                          begin
                            Dec(Pos);
                            Delete(St, Pos, 1);
                          end;
                      end;
                  else if Ch <> #13 then
                    begin
                      Insert(Ch, St, Pos);
                      Inc(Pos);
                    end;
                end;
              end;
            if (TextWidth(St) + X) > (GetMaxX - 10) then
              begin
                X := 10;
                ppy := 20;
              end;
          end;
        Napis;
        Poc := 1;
        Kurz;
      end;
  until (Ch = #27) or (Ch = #13);
  if Ch = #13 then CitajText2 := St
   else CitajText2 := 'ESC';
end;




procedure Bod(X, Y, C, Velkost: integer);
var i,j,Col: Integer;
begin
  for I := X to X + Velkost - 1 do
    for J := Y to Y + Velkost - 1 do
      begin
        Col := GetPixel(I, J);
        PutPixel(I, J, C);
      end;
end;


procedure VymazBoky;
begin
  Vymaz(0, 0, 10, MaxY, 0); {vlavo}
  Vymaz(0, 0, MaxX, 65, 0); { hore }
  Vymaz(MaxX - 15, 0, MaxX, MaxY, 0); {vpravo}
  Vymaz(0, MaxY - 35, MaxX, MaxY, 0); {dole}
  if PaletaVisible then Vymaz(MaxX - 100, 0, MaxX, 100, 0); {sipka}
end;

procedure PripravPozadie;
begin
  Execute(Pozadie + ' /N'); { /FADEIN');}
  Vymaz(MaxX - 160, MaxY - 60, MaxX, MaxY, 0); {Grabber prekryt}
end;



procedure AutorText;
var St, St1: string;
begin
  St := ProgDescrib;
  St1 := 'F1 - Help';
  SetColor(47);
  TextDoStredu(741, St);
  SetColor(254);
  TextDoStredu(740, St);
  SetColor(233);
  OutTextXY(20, 745, St1);
  OutTextXY(21, 746, St1);
end;

procedure Stav;
var St, St1, St2, St3: string;
    H, M, S, SS, D: word;
begin
  SetTextStyle(0,0,1);
  Vymaz(0, 0, MaxX - 50, 17, 0);
  SetColor(255);
  Str(X:3, St); OutTextXY(10,10, 'X:' + St);
  Str(Y:3, St); OutTextXY(60,10, 'Y:' + St);
  Str(CColor, St); OutTextXY(110,10, 'Ccol:' + St);
  Str(Tlac, St);  OutTextXY(190,10, 'Tlac:' + St);
  Str(Speed, St); OutTextXY(250,10, 'Speed:' + St);
  OutTextXY(325, 10, 'Draw:' + Chr(Ord(Draw) + 48));
  OutTextXY(380, 10, 'Saved:' + Chr(Ord(Saved) + 48));
  Str(Color, St); OutTextXY(440,10, 'Farba:' + St);
  Str(T_Cislo, St); OutTextXY(520,10, 'T_Cislo:' + St);
  Str(P_Cislo, St); OutTextXY(630,10, 'P_Cislo:' + St);
  SetColor(237);
  OutTextXY(720, 10, 'File_Name:' + F_Name);
  GetTime(H, M, S, SS);
  SetColor(255);
  Str(H, St); OutTextXY(900,10, St + ':' + DoplnNulu(M));
end;


procedure StavInformacii;
var Skm, Srok, Sden, Smesiac: string; CDna: word;
begin
  Vymaz(0, 30, MaxX - 100, 60, 0);
  SetColor(55);
  Str(Km, Skm);
  with CasVyletu do
    begin
      SetDate(Rok, Mesiac, Den); {nastavy pomosny datum na zistenie Dna}
      GetDate(PomWord, PomWord, PomWord, CDna); {posledne sa vyuzije}
      {----}
      Str(Rok, SRok);
      Str(Mesiac:2, SMesiac);
      Str(Den, SDen);
      {---}
      OutTextXY(10, 30, '[K] pocet Kilometrov (Km): ' + Skm +
          '                       ' +
          '[D] Datum konania vyletu: ' + NazovDna[CDna] + ' - '
          + SDen + '.' + SMesiac + '.' + SRok);
    end;

  SetDate(Rok, Mesiac, Den); {naspet vrati aktualny deatum}

  OutTextXY(10, 40, '[P] Popis obsahu suboru (maximalne 20 znakov): ' + Popis);
  OutTextXY(10, 50, '[T] sprievodny Text (max. 200 znakov): ' + Text);
end;


procedure Paleta;
var x, y, x1, y1, x2, y2: integer; St: string;
begin
  if PaletaVisible then
    begin
      Vymaz(890, 0, MaxX, MaxY, 0);
      X := 900;
      for Y := 0 to 255 do
        begin
          x1 := X + (Y div 64) * 30;
          y1 := Y * 10 - (Y div 64) * 640 + 102;
          x2 := x1 + 28;
          y2 := y1 + 8;
          SetColor(1);
          Vymaz(x1, y1, x2, y2 ,y);
          Str(Y, St);
          OutTextXY(x1, y1, St);
        end;
    end;
end;

procedure VyHlaska;  {vymaz to}
begin
  Vymaz(0, 18, MaxX, 28, 0);
end;


procedure Hlaska(Sprava: string);
begin
  VyHlaska;
  SetColor(250);
  OutTextXY(5, 20, '--- ' + Sprava);
end;



procedure CursorLupa(Zoom: integer);
const Vel = 10;
var Pole: array[1..Vel,1..Vel] of integer;
    I, J, C: integer;
begin
  for I := 1 to Vel do
    for J := 1 to Vel do
      Pole[I, J] := GetPixel(X+I-1,Y+J-1);

  for I := 1 to (Vel * 3) do
    for J := 1 to (Vel * 3) do
      PutPixel(X + I - 1, J + Y - 1, Pole[I div 3, J div 3]);

end;




procedure Lupa;
const Vel = 40;
     Zoom = 2;
var Pole: array[1..Vel,1..Vel] of integer;
    I, J, C: integer;
begin
  if LupaVisible then
   begin
     for I := 1 to Vel do
       for J := 1 to Vel do
         Pole[I, J] := GetPixel(X + I - Vel div 2, Y + J - Vel div 2);
     for I := 1 to Vel * Zoom do
       for J := 1 to Vel * Zoom do
         begin
           PutPixel(I + 20, 660 + J, Pole[I div Zoom + 1, J div Zoom + 1]);
         end;
   end;
end;


procedure Skontoluj_Ci_Mys_nema_Vela;
  procedure Hl;
  begin
    Hlaska('Dalej s mysou uz nepohnes...');
  end;
begin
    if Y < 50 then
    begin
      Hl;
      Y := 50;
      MousePos(X, Y);
    end;

    if Y > 730 then
    begin
      Hl;
      Y := 735;
      MousePos(X, Y);
    end;

    if X < 22 then
    begin
      Hl;
      X := 22;
      MousePos(X, Y);
    end;

    if X > 1000 then
    begin
      Hl;
      X := 1000;
      MousePos(X, Y);
    end;
end;






procedure SavePoz;
var U: byte;
begin
  U := PodSize div 2;
  GetImage(X - U, Y - U, X + U, Y + U, Podlozka^);
end;


procedure LoadPoz;
var U: byte;
begin
  U := PodSize div 2;
  PutImage(OldX - U, OldY - U, Podlozka^, 0);
end;


function ArcTan(X: real): real;
begin
  ArcTan := (1 / Sin(X)) /  (1 / Cos(X));
end;


function Je(A, B, C: integer): boolean;
begin
  Je := FALSE;
  if (A <= B) and (B <= C) then Je := TRUE;
end;




procedure Kurzor;
var U: byte;
   St: string;
   TColor: byte;

  procedure Sipka(X, Y: longint);
  begin
  if (MaxX - X) >= Y then
    begin
      PomX := MaxX - 100;
      PomY := Trunc( (Y * 100) / (MaxX - X));
     end
   else
    begin
      PomX := Trunc(MaxX - (((MaxX - X) * 100) / Y));
      PomY := 100;
    end;
  end;


begin
  SetLineStyle(1, 0, 1);
  TColor := 250;
  if Draw then TColor := 224;
  SetColor(TColor);
  Circle(X, Y, 13);
  SetColor(0);
  Circle(X, Y, 14);
  Circle(X, Y, 12);
  Line(X, Y - 13, X, Y + 12);
  Line(X - 13, Y, X + 12, Y);
  {--- b o k y ---}
    begin
      SetLineStyle(0, 0, 0);
      SetColor(0);
      Line(0, OldY, 10, OldY);
      Str(OldY:3, St);
      OuttextXY(0, OldY + 5, St[1]);
      OuttextXY(0, OldY + 14, St[2]);
      OuttextXY(0, OldY + 23, St[3]);
      Line(OldX, MaxY - 10, OldX, MaxY);
      Str(oldX, St);
      OuttextXY(oldX, MaxY - 10, ' ' + St);
      SetColor(TColor);
      Line(0, Y, 10, Y);
      Str(Y:3, St);
      OuttextXY(0, Y + 5, St[1]);
      OuttextXY(0, Y + 14, St[2]);
      OuttextXY(0, Y + 23, St[3]);
      Line(X, MaxY - 10, X, MaxY);
      Str(X, St);
      OuttextXY(X, MaxY - 10, ' ' + St);
    end;
 {---- sipka -----}
  if PaletaVisible then
    begin
      Sipka(OldX, OldY);
      SetColor(0);
      Line(PomX, PomY, MaxX, 0);
      Sipka(X, Y);
      SetColor(83);
      Line(PomX, PomY, MaxX, 0);
    end;
end;



procedure FarebnaPlocha;
var St: string; plX, dlX: _X; plY, dlY: _Y;
begin
  if PaletaVisible then
    begin {vpravo dole}
      plX := 780;
      plY := 660;
      dlX := 90;
      dlY := 90;
    end
   else
    begin {vpravo hore}
     plX := MaxX - 100;
     plY := 30;
     dlX := 100;
     dlY := 35;
    end;

  Vymaz(plX, plY, plX + dlX, plY + dlY, Color);

  Str(Color, St);
  SetColor(0);
  if Color = 0 then SetColor(255);
  OutTextXY(plX + 5, plY + 20, St);
end;


procedure NastavFarbu;
var St: string;
begin
   Color := CColor;
   FarebnaPlocha;
   Str(Color, St);
   Hlaska('Nova farba nastavena: ' + St);
end;


procedure DrawCiaru;
begin
 if Draw then
   begin
     SetColor(Color);
     {Bod(X, Y, Color, 3);}
     SetLineStyle(0, 0, 3);
     Line(OldX, OldY, X, Y);
   end;
end;

function Odpoved_ANO: boolean;
var Ch: char;
begin
  repeat
    Ch := UpCase(ReadKey);
  until Ch in ['A', 'Y', 'N', #13, #27];
  if Ch in ['A', 'Y', #13] then Odpoved_ANO := TRUE
   else Odpoved_ANO := FALSE;
end;

function Odpoved_NIE: boolean;
var Ch: char;
begin
  repeat
    Ch := UpCase(ReadKey);
  until Ch in ['A', 'Y', 'N', #13, #27];
  if Ch in ['N', #27] then Odpoved_NIE := TRUE
   else Odpoved_NIE := FALSE;
end;

procedure NapisCRtext(X: _X; Y: _Y; Color: byte; Text: string);
var CRs, K: byte; PomSt: string; pX: _X; pY: _Y;
begin
  PomSt := '';
  CRs := 0;
  for K := 1 to Length(Text) do
    begin
      if Text[K] = #13 then
        begin
          Inc(CRs);
          PomSt := '';
        end
       else
        begin
          PomSt := PomSt + Text[K];
          pX := X + TextWidth(PomSt);
          pY := Y + CRs * (TextHeight(PomSt) + 1);
          {cierne}
          SetColor(0);
          OutTextXY(pX + 1, pY + 1, Text[K]);
          {prave'}
          SetColor(Color);
          OutTextXY(pX, pY, Text[K]);
        end;
     end;
end;

procedure QuickPlay;  {RYCHLE VYKRESLENIE UDAJOV}
var  PomSt: string;
          CRs: byte;
           pX: _X;
           pY: _Y;
begin
  SetLineStyle(0, 0, 3);
  for I := 1 to T_Cislo do with Trasa[I] do
    begin
      SetColor(Farba);
      Line(X1, Y1, X2, Y2);
      for J := 1 to P_Cislo do if Poznam[J].Cislo = I then with Poznam[J] do
        begin
          NapisCRtext(X1, Y1, Farba, Text)
        end;
    end;
end;



procedure RedrawScreen;
var LogoX: _X;
begin
  if PaletaVisible then LogoX := 115 else LogoX := 870;
  PripravPozadie;
  VymazBoky;
  Logo(LogoX, 715);
  Stempel(LogoX + 70, 715);
  AutorText;
  Paleta;
  Lupa;
  Stav;
  StavInformacii;
  QuickPlay;
  SavePoz;
end;


procedure QuickSave;
var F_I: file of _info;
    F_T: file of _trasa;
    F_P: file of _poznam;
    U_info: _info;
    U_trasa: _trasa;
    U_poznam: _poznam;

begin
  Hlaska('Uklada sa ' + F_name);
    with U_info do
      begin
        T_Pocet := T_Cislo;
        P_Pocet := P_Cislo;
        FileHead := ' Marek Laco/1997, datovy subor - bicyklovy vylet.' +
                      ' Autorske prava vyhradene podla Z.c.52f/1995 Zb.z. ' +
                      ' Patent No. 1997laco01482256Sk ';
      end;
  U_Info.Text := Text;
  U_Info.Popis := Popis;
  U_Info.Km := Km;
  U_Info.CasVyletu := CasVyletu;
  U_Info.CasVzniku := CasVzniku;
  U_Info.Pozadie := Pozadie;
  Assign(F_I, F_Name);
  ReWrite(F_I);
  Write(F_I, U_info);
  Close(F_I);

  Assign(F_T, F_Name);
  Reset(F_T);
  {Seek(F_T, SizeOf(_info) div 9);}
  Seek(F_T, FileSize(F_T) + 1);
  {preco?, preco? preco? musi byt +1 aby to slo?}
  for I := 1 to T_Cislo do Write(F_T, Trasa[I]);
  Close(F_T);
  Assign(F_P, F_Name);
  Reset(F_P);
  {Seek(F_P, (SizeOf(_info) div 9) + T_Cislo * (SizeOf(_Trasa) div 9));}
  Seek(F_P, FileSize(F_P));
  {
  closegraph;
  writeln(T_Cislo, ' - ', FileSize(F_p));
  halt(0);
  }
  for I := 1 to P_Cislo do Write(F_P, Poznam[I]);
  Close(F_P);

  F_Size := FileVelkost(F_Name);
  Hlaska(F_Name + ' ulozeny, jeho velkost = '+ Velkost(F_Size));
  Saved := TRUE;
end;

function MuozesPrepisat(Koho: string): boolean;
begin
  Hlaska('Subor ' + Koho + ' uz na disku je, prepisat? ' + ANO_NIE_Str);
  if Odpoved_ANO then MuozesPrepisat := TRUE
   else MuozesPrepisat := FALSE;
end;

procedure Ci_Ulozit_Pracu;
var
       F_I: file of _info;
    U_info: _info;
    St, St1, St2: string;
   Search: searchrec;
 F_NameList: array[1..30] of string[12];
      Pol: array[1..30] of string[100];
    PomStr: string;
    Datum: datetime;
    Pocet: byte;
        X: _X;
        Y: _Y;
        I: byte;
       Ch: char;
begin
  Pocet := 0;
  FindFirst('*.TRP', Archive, Search);
  while DosError = 0 do
    begin
      Inc(Pocet);
      UnPackTime(Search.Time, Datum);
      st := LowStr(Search.Name);
      while Length(St) < 12 do St := St + ' ';
      PomStr := '';
      PomStr := PomStr + St + '   ';
      PomStr := PomStr + Velkost(Search.Size) + '   ';
      with Datum do
        begin
          Str(Day:2, St);
          PomStr := PomStr + St + '.';
          St := DoplnNulu(Month);
          PomStr := PomStr + St + '.';
          Str(Year, St);
          PomStr := PomStr + St + ' ';
          Str(Hour:2, St);
          PomStr := PomStr + St + ':';
          St := DoplnNulu(Min);
          PomStr := PomStr + St + ':';
          St := DoplnNulu(Sec);
          PomStr := PomStr + St + '   ';
        end;
      Assign(F_I, Search.Name);
      Reset(F_I);
      Read(F_I, U_info);
      Close(F_I);
      St := u_info.pozadie;
      while Length(st) < 12 do St := St + ' ';
      PomStr := PomStr + St + '   ';
      PomStr := PomStr + u_info.Popis;
      Pol[Pocet] := PomStr;
      F_NameList[Pocet] := Search.Name;
      FindNext(Search);
    end;
  if Pocet > 0 then
    begin
      {------- uz to mame nacitane ------}
      X := 100;
      Y := 200;
      {SaveCastObrazovky(X - 50, Y - 50, MaxX - X, Y + 10 * Pocet + 50);}
      Vymaz(X - 50, Y - 50, MaxX - X, Y + 10 * Pocet + 50, 0);
      SetColor(114);
      for i := 1 to Pocet do OutTextXY(X, Y + 10 * (i - 1), Pol[i]);
      OutTextXY(X, Y - 15, 'Meno suboru    Velkost   Datum a cas vzniku    Pozadie        Poznamka k suboru');
    end;
  Hlaska('Ulozit hodnoty do suboru (ESC - zrusit): ');
  PomStr := CitajText2(370, 20, 253, F_Name);
  PomStr := UpStr(FileName(PomStr) + F_Ext);
  if (PomStr <> ('ESC' + F_Ext)) and ((FileExist(PomStr) = FALSE)
                      or (FileExist(PomStr) and MuozesPrepisat(PomStr))) then
    begin
      F_Name := PomStr;
      QuickSave;
      RedrawScreen; {prepisat tabulku s f_name ami}
      Hlaska(F_Name + ' ulozeny, jeho velkost = '+ Velkost(F_Size));
    end
   else
     begin
       RedrawScreen;
       Hlaska('?? ! @%3$&^ ?? hrrr pch!? - strachoput');
     end;
   Ch := #0;
end;


function Ci_Skoncit: boolean;
begin
  Ci_Skoncit := TRUE;
  Hlaska('Ukoncit program?  /inak od posledneho zapisu si neurobil zmeny/   '
                        + ANO_NIE_Str);
  if Odpoved_ANO then
    begin
      Hlaska('Bye - Bye');
      Ch := #27;
    end
   else
    begin
      Ci_Skoncit := FALSE;
      Hlaska('No vydis, pokracuj pekne dalej! - ROME WAS NOT BUILT IN ONE DAY!');
    end;
end;


procedure Informacie_Na_Dobru_Noc;
begin
  Writeln;
  Writeln(ProgDescrib);
  Writeln(Autor);
  Writeln('Seriove cislo: ' + SerCislo);
  Writeln;
  Writeln;
  Writeln('-------------------------------------------------------------');
  Writeln('subor: ', F_Name, ', ', Velkost(FileVelkost(F_Name)));
  Write('subor bol nakoniec ulozeny: ');
  if Saved then Writeln('ano') else Writeln('NIE!');
  Writeln('suradnic (T_cislo): ', T_Cislo);
  Writeln('poznamok (P_Cislo): ', P_Cislo);
  for i := 1 to P_Cislo do writeln(i, '. p. Text: ', Poznam[i].text );
  Writeln('pocet Kilometrov (Km): ', Km);
  Writeln('Popis suboru [20]: ', Popis);
  Writeln('sprievodny Text [200]: ', Text);
  with CasVyletu do
  Writeln('Datum konamia vyletu: ', Den, '.', Mesiac:2, '.', Rok);
end;





procedure Help;
var hXStred, X: _X; hY1, hY2: _Y;
    I: byte;
    S: searchrec;
    F_Datum: datetime;
    St, St1, St2, St3, St4, St5, St6, St7, St8, St9: string;
    Srok, Smesiac, Sden, Shodina, Sminuta, Ssekunda, SNazovDna: string;
    Strin: array[1..22] of string;
    strin1: array[1..3] of string;
begin
  Hlaska('Precitaj si Help a stlac klavesu...');
  st  := 'Editor Vyletov';
  st1 := ProgDescrib;
  st2 := Autor; 
  st3 := 'Pouzitie klavesnice';
  st8 := '   Pouzitie mysi   ';
  st9 := '   Pecat kvality   ';
  st4 := '-------------------';
  strin[1] := 'F1,H - Help (tato obrazovka)';
  strin[2] := 'F2,S - Save, ulozit data do suboru';
  strin[3] := 'F3,L - Load, nacitat subor';
  strin[4] := 'F4,N - New, vynulovat hodnoty';
  strin[5] := 'F6 - QuickSave, ulozit bez reptania ';
  strin[6] := 'F10, Alt-X, Ctrl-Q - ukoncit program';
  strin[7] := '';
  strin[8] := 'W - vlozenie poznamky na poziciu kurzora';
  strin[9] := 'K - zadanie poctu kilometrov';
  strin[10] := 'P - vlozenie popisu suboru, max 20 znakov';
  strin[11] := 'T - poznamka k vyletu, 200 znakov';
  strin[12] := 'D - zadanie datumu konania vyletu';
  strin[13] := '';
  strin[14] := 'R - Redraw, znovuvykreslenie obrazovky';
  strin[15] := 'Z - preview';
  strin[16] := '';
  strin[17] := 'SPACE - kreslenie on/off';
  strin[18] := 'TAB   - paleta on/off';
  strin[19] := 'ENTER - zvolenie farby pod kurzorom';
  strin[20] := '';
  strin[21] := 'ALT-0..9 - ulozenie farby do pozicie';
  strin[22] := '0..9 - vyvolanie farby z pozicie';
  strin1[1] := 'LAVE TLACITKO - kreslenie on/off';
  strin1[2] := 'PRAVE TLACITKO - znehybnenie mysi on/off';
  strin1[3] := 'pohyb - pohyb kurzora';
  {--zistenie casu kompilovania---}
  FindFirst(Prog_F_Name, $3f, S);
  if Doserror <> 0 then Abord('chyba pri VYLED.EXE');
  UnpackTime(S.Time, F_Datum);
  with F_Datum do
    begin
      Str(Year, Srok);
      Str(Month, Smesiac);
      Str(Day, Sden);
      Str(Hour, Shodina);
      Sminuta := DoplnNulu(Min);
      SSekunda := DoplnNulu(Sec);
      SetDate(Year, Month, Day);
      GetDate(PomWord, PomWord, PomWord, Cdna);
      SNazovDna := NazovDna[CDna];
    end;
  SetDate(Rok, Mesiac, Den); {naspet vrati aktualny deatum}
  {-----}
  hXStred := 200;
  X := (GetMaxX div 2) - 170;
  hY1 := 100;
  hY2 := MaxY - 100;
  RamcekStred(hXStred + 2, hY1 - 2, hY2 + 2, 255, 1, 0);
  RamcekStred(hXStred, hY1, hY2, 0, 3, -1);
  RamcekStred(hXStred - 3, hY1 + 3, hY2 - 3, 253, 3, -1);
  SetColor(255);
  TextDoStredu(120, St);
  TextDoStredu(130, St1);
  TextDoStredu(150, St2);
  TextDoStredu(190, St3);
  TextDoStredu(200, St4);
  for i := 1 to 22 do OutTextXY(X, 200 + i * 10, strin[i]);
  TextDoStredu(440, St8);
  TextDoStredu(450, St4);
  for i := 1 to 3 do OutTextXY(X, 450 + i * 10, strin1[i]);
  TextDoStredu(510, St9);
  TextDoStredu(520, St4);
  OutTextXY(X, 640, 'Naposledy kompilovane:');
  OutTextXY(X, 650, '  ' + SnazovDna + ' - ' + SDen + '.' + Smesiac + '.' + Srok
                    + '  ' + Shodina + ':' + Sminuta + ':' + Ssekunda
                    + '  ml/pascal');
  Logo(GetmaxX div 2 - 70, 540);
  Stempel(GetmaxX div 2 + 10, 540);
  Readkey;
  RedrawScreen;
  Hlaska('Help docitany''...');
end;

procedure SaveCastObrazovky(X1: _X; Y1: _Y; X2: _X; Y2: _Y);
type _Bod = record
              X: _X;
              Y: _Y;
              Farba: byte;
            end;
var bod: _Bod;
    Subor: file of _bod;
    X: _X;
    Y: _Y;
begin
  Assign(Subor, 'TEMP.$$$');
  ReWrite(Subor);
  for X := X1 to X2 do
   for Y := Y1 to Y2 do
      begin
        Bod.X := X;
        Bod.Y := Y;
        Bod.Farba := GetPixel(X, Y);
        Write(Subor, Bod);
      end;
  Close(Subor);
end;


procedure LoadCastObrazovky;
type _Bod = record
              X: _X;
              Y: _Y;
              Farba: byte;
            end;
var bod: _Bod;
    Subor: file of _bod;
    X: _X;
    Y: _Y;

begin
  Assign(Subor, 'TEMP.$$$');
  Reset(Subor);
  while not Eof(Subor) do
   begin
     Read(Subor, Bod);
     PutPixel(Bod.X, Bod.Y, Bod.Farba);
   end;
  Close(Subor);
  Erase(Subor);
end;

procedure Nuluj_Vsetky_Data;
begin
  T_Cislo := 1;  {pre to aby mohla fungovat poznamka a citanie,}
  P_Cislo := 0;   { musi byt T_Cislo uz na caciatku 1}
  with Trasa[1] do
    begin
      X1 := 0;
      Y1 := 0;
      X2 := 0;
      Y2 := 0;
      Farba := 0;
    end;
  Km := 0;
  Popis := '';
  Text := '';
  GetTime(Hod, Minuta, PomWord, PomWord);
  GetDate(Rok, Mesiac, Den, CDna);
  with CasVzniku do
    begin
      Year := Rok;
      Month := Mesiac;
      Day := Den;
      Hour := Hod;
      Min := Minuta;
      Sec := CDna;
    end;
  CasVyletu.Den := Den;
  CasVyletu.Mesiac := Mesiac;
  CasVyletu.Rok := Rok;
end;


procedure NewData;
var St: string;
begin
  if Saved then St := '/subor bol ulozeny/'
   else St := '/subor este nebol ulozeny/';
  Hlaska('Vynulovat vsetky hodnoty v ' + F_Name + ', ' + St + '?     ' + ANO_NIE_Str);
  if Odpoved_ANO = FALSE then Hlaska('Ale ja som to uz vymazal, nevadi?...... (vtip)')
   else
   begin
     Nuluj_Vsetky_Data;
     RedrawScreen;
     Hlaska('No, dorbe, zacinas znovu na cistom stole');
   end;
end;


function Fx(A: word): word;  {stara f, ta bola 2-776776776}
var    X: longint;
    Pole: array[1..5005] of byte;
 PomPole: array[1..3] of byte;
  function SucetPoloziekPo(C: word): longint;
  var Pom, I: longint;
  begin
    Pom := 0;
    for I := 1 to C do Inc(Pom, Pole[i]);
    SucetPoloziekPo := Pom;
  end;
begin
  PomPole[1] := 7;
  PomPole[2] := 7;
  PomPole[3] := 6;

  Pole[1] := 2;
  for X := 2 to 5000 do Pole[X] := PomPole[((X - 2) mod 3) + 1];
  X := 0;
  repeat
    Inc(X)
  until SucetPoloziekPo(X) >= A;
  Inc(X, 4);
  Fx := X;
end;

function F(A: word): word;  {nova f, tato je 5-76776776}
var    X: longint;
    Pole: array[1..5005] of byte;
 PomPole: array[1..3] of byte;
  function SucetPoloziekPo(C: word): longint;
  var Pom, I: longint;
  begin
    Pom := 0;
    for I := 1 to C do Inc(Pom, Pole[i]);
    SucetPoloziekPo := Pom;
  end;
begin
  PomPole[1] := 7;
  PomPole[2] := 6;
  PomPole[3] := 7;

  Pole[1] := 5;
  for X := 2 to 5000 do Pole[X] := PomPole[((X - 2) mod 3) + 1];
  X := 0;
  repeat
    Inc(X)
  until SucetPoloziekPo(X) >= A;
  Inc(X, 4);
  F := X;
end;


function VyberTenSpravny: boolean;
var Search: searchrec;
 F_NameList: array[1..30] of string[12];
      Pol: array[1..30] of string[100];
    PomStr, St: string;
    Datum: datetime;
    Pocet: byte;
      F_I: file of _info;
   u_info: _info;
        X: _X;
        Y: _Y;
        I: byte;
       Ch: char;
begin
  Pocet := 0;
  FindFirst('*.TRP', Archive, Search);
  while DosError = 0 do
    begin
      Inc(Pocet);
      UnPackTime(Search.Time, Datum);
      st := LowStr(Search.Name);
      while Length(St) < 12 do St := St + ' ';
      PomStr := '';
      PomStr := PomStr + St + '   ';
      PomStr := PomStr + Velkost(Search.Size) + '   ';
      with Datum do
        begin
          Str(Day:2, St);
          PomStr := PomStr + St + '.';
          St := DoplnNulu(Month);
          PomStr := PomStr + St + '.';
          Str(Year, St);
          PomStr := PomStr + St + ' ';
          Str(Hour:2, St);
          PomStr := PomStr + St + ':';
          St := DoplnNulu(Min);
          PomStr := PomStr + St + ':';
          St := DoplnNulu(Sec);
          PomStr := PomStr + St + '   ';
        end;
      Assign(F_I, Search.Name);
      Reset(F_I);
      Read(F_I, U_info);
      Close(F_I);
      St := u_info.pozadie;
      while Length(st) < 12 do St := St + ' ';
      PomStr := PomStr + St + '   ';
      PomStr := PomStr + u_info.Popis;
      Pol[Pocet] := PomStr;
      F_NameList[Pocet] := Search.Name;
      FindNext(Search);
    end;
  if Pocet = 0 then
    begin
      Hlaska('LOAD: V adresary niesu ziadne *.TRP, nemam co citat!');
      VyberTenSpravny := FALSE;
      Exit;
    end;
  {------- uz to mame nacitane ------}
  Hlaska('Vyber si subor, ktory sa ma nacitat');
  X := 100;
  Y := 200;
  {SaveCastObrazovky(X - 50, Y - 50, MaxX - X, Y + 10 * Pocet + 50);}
  Vymaz(X - 50, Y - 50, MaxX - X - 50, Y + 10 * Pocet + 50, 0);
  SetColor(255);
  for i := 1 to Pocet do OutTextXY(X, Y + 10 * (i - 1), Pol[i]);
  SetColor(253);
  OutTextXY(X, Y - 15, 'Meno suboru    Velkost   Datum a cas vzniku    Pozadie        Poznamka k suboru');
  I := 1;
  SetColor(157);
  OutTextXY(X - 24, Y + 10 * (i - 1), '-->' + Pol[i]);
  repeat
    Ch := Upcase(ReadKey);
    SetColor(0);
    OutTextXY(X - 24, Y + 10 * (i - 1), '-->');
    SetColor(255);
    OutTextXY(X, Y + 10 * (i - 1), Pol[i]);
    case Klavesa(Ch) of
      7,4: i := 1;
      1,6: i := Pocet;
      8: if i > 1 then Dec(i);
      2: if i < pocet then Inc(i);
    end;
    SetColor(157);
    OutTextXY(X - 24, Y + 10 * (i - 1), '-->' + Pol[i]);
    St := F_NameList[i];
    while Length(St) < 12 do St := St + ' ';
    Hlaska('Vyberas si ' + St + '?   ENTER - ano,   ESC - zrusit,   sipky - ina volba');
  until (Ch = #27) or (Ch = #13);
  if Ch = #27 then
    begin
      VyberTenSpravny := FALSE;
      Vymaz(X - 50, Y - 50, MaxX - X - 50, Y + 10 * Pocet + 50, 0);
      if F_Name <> '' then RedrawScreen;
      {LoadCastObrazovky;}
      Hlaska('ESC stlacene, prerusenie');
    end
   else
    begin
      VyberTenSpravny := TRUE;
      F_Name := F_NameList[i];
    end;

end;

procedure LoadData;
var F_I: file of _info;
    F_T: file of _trasa;
    F_P: file of _poznam;
    U_info: _info;
    U_trasa: _trasa;
    U_poznam: _poznam;
    I: word;
begin
  if VyberTenSpravny then
    begin
      Hlaska('Nacitavam: ' + F_Name + ' ...');
      Nuluj_Vsetky_Data; {Pre Istotu}
      Assign(F_I, F_Name);
      Reset(F_I);
      Read(F_I, U_info);
      Close(F_I);
      T_Cislo := U_info.T_Pocet;
      P_Cislo := U_info.P_Pocet;
      Text := U_info.Text;
      Popis := U_info.Popis;
      Pozadie := U_info.Pozadie;
      CasVzniku := U_info.CasVzniku;
      CasVyletu := U_info.CasVyletu;
      Km := U_Info.Km;
      if FileExist(Pozadie) = FALSE then Abord('subor ' + Pozadie + ' sa nenachadza na disku');
      Assign(F_T, F_Name);
      Reset(F_T);
      Seek(F_T, SizeOf(_info) div 9);
      {Neviem si vysvetlit, preco to musi byt div 9, ?????????!}
      {Seek(F_T, 37);}
      for I := 1 to T_Cislo do Read(F_T, Trasa[I]);
      Close(F_T);
      Assign(F_P, F_Name);
      Reset(F_P);
      Seek(F_P, F(T_Cislo) + 1);
      for I := 1 to P_Cislo do Read(F_P, Poznam[I]);
      Close(F_P);
      {Poznamka}
      {--------}
      {Porsim vas, ty, ktory tento zdrojak kedy budu citat, nech sa ma potom}
      {nepitaju, precom som pred par riadkami pouzil pri prikaze Seek / urcenie}
      {pozicie v subora na citanie/ moju c^udnu' funkciu F(); - ta musi, neviem}
      {sice preco, vypocitat prave take cislo od cisla T_Cislo, aby to}
      {reprezentovalo poziciu prveho zaznamu _Poznam v subore, je to taky}
      {cudny system, ze od cisla 1,2 vrati 5    F([1/2] = 5}
      {a F[3 az 9]= 6,  , potom 7, 8, 9....}
      {zaujimave je to, co nechapem preco tomu musi byt tak, ze}
      {cislo 5 sa vrati 2 krat, ale cislo 6 uz 7 krat, 7 - 7krat, 8-6krat}
      {9-7krat, 10-7krat, 11-6krat, sequencia je 2,7,7,6,7,7,6,7,7,6,7,7,6,...}
      {Preco???????, preco nastaci zadat proste poziciu v bytoch, ktora by sa}
      {vypocitala jednoducho = (T_Cislo * PocetZaznamov) / DakaKonstanta}
      RedrawScreen;
      Hlaska(F_Name + ' je stastlivo nacitany');
    end;
end;


procedure Play; {Pusti sequenciu}
var St, St1, St2, PomSt: string;
    CRs: byte;
    I, J, K, Opak, Pos: longint;
    PX, PomX, PomOX: _X;
    PY, PomY, PomOY: _Y;
begin
  PomX := X;
  PomY := Y;
  PomOX := OldX;
  PomOY := OldY;
  Opak := 0;
  if T_Cislo > 1 then
    begin
  repeat
    PripravPozadie;
    for I := 1 to T_Cislo do with Trasa[I] do
    begin
      Str(((I / T_Cislo) * 100):3:0, St);
      Hlaska('Preview..., Stlac ESC - prerusenie       Progress ' + St + '%');
      X := X2;
      Y := Y2;
      OldX := X1;
      OldY := Y1;
      SetLineStyle(0, 0, 3);
      SetColor(Farba + Opak);
      Line(X1, Y1, X2, Y2);
      Lupa;
       for J := 1 to P_Cislo do
        if Poznam[J].Cislo = I then
         with Poznam[J] do
           begin
             St := '';
             PomSt := '';
             CRs := 0;
             for K := 1 to Length(Text) do
               begin
                 if Text[K] = #13 then
                   begin
                     Inc(CRs);
                     PomSt := '';
                   end
                  else
                   begin
                     PomSt := PomSt + Text[K];
                     pX := X1 + TextWidth(PomSt);
                     pY := Y1 + CRs * (TextHeight(PomSt) + 1);
                     {cierne}
                     SetColor(0);
                     OutTextXY(pX + 1, pY + 1, Text[K]);
                     {prave'}
                     SetColor(Farba + Opak);
                     OutTextXY(pX, pY, Text[K]);
                   end;
               end;
           end;
       if keypressed then I := T_Cislo;
    end;
    {Inc(Opak);}  {Zmena farby po cykle}
  until keypressed;
  readkey;
  RedrawScreen;
  Hlaska('Preview ukoncene');
  X := PomX;
  Y := PomY;
  OldX := PomOX;
  OldY := PomOY;
  MousePos(X, Y); {treba upravit mysku}
  SavePoz;
  Kurzor;
    end
   else Hlaska('Vela si toho este neurobil, nieje co pozerat.');
end;




procedure ImputPoznamku;
var St, SColor, SX, SY: string;
begin
  Hlaska('Napis text,  ENTER - dalsi riadok,   ESC - koniec vkladania');
  LoadPoz;
{  SetTextStyle(0,0,2);}
  St := CitajText(X, Y, Color);
  if Length(St) > 1 then
    begin
      SavePoz;
      Inc(P_Cislo);
      with Poznam[P_Cislo] do
        begin
          X1 := X;
          Y1 := Y;
          Farba := Color;
          Text := St;
          Cislo := T_Cislo;
        end;
     Str(Color, SColor);
     Str(X, SX);
     Str(Y, SY);
     Hlaska('Poznamka vlozena:   X:' + SX + ' Y:' + SY + ' Farba:' + SColor + ' Text: ' + St);
     Saved := FALSE;
   end
  else Hlaska('Poznamka neplatna...');
end;



procedure ImputKilometre;
var St, Skm: string; Pkm: word; Code: integer;
begin
  Hlaska('Napis pocet kilometrov, len cislice ENTER - koniec,   ESC - zrusit');
  Str(Km, Skm);
  St := CitajText2(226, 30, 253, Skm);
  if St = 'ESC' then Hlaska('ESC - prerusenie')
   else
    begin
      Val(St, Pkm, Code);
      if Code <> 0 then Hlaska('CHYBA - bolo treba vlozit len cislice a nie ' + St)
       else
        begin
          Km := Pkm;
          Hlaska('OK - vlozene kilometre: ' + St);
          Saved := FALSE;
        end;
    end;
  StavInformacii;
end;


procedure ImputPopis;
var St: string;
begin
  Hlaska('Napis popis obsahu suboru ' + F_Name +
   '. Maximalne ale iba 20 znakov, ostatne budu odseknute,    ENTER - koniec,   ESC - zrusit');
  St := CitajText2(386, 40, 253, Popis);
  if St = 'ESC' then Hlaska('ESC - prerusenie')
   else
    begin
      Popis := St;
      Hlaska('OK - vlozeny popis obsahu suboru ' + F_Name + ': ' + St);
      Saved := FALSE;
    end;
  StavInformacii;
end;

procedure ImputText;
var St: string;
begin
  Hlaska('Napis sprievodny text k vyletu v subore ' + F_Name +
   '. Max. 200 znakov,    ENTER - koniec,   ESC - zrusit');
  St := CitajText2(322, 50, 253, Text);
  if St = 'ESC' then Hlaska('ESC - prerusenie')
   else
    begin
      Text := St;
      Hlaska('OK - vlozeny sprievodny text k obsahu suboru ' + F_Name + ': ' + St);
      Saved := FALSE;
    end;
  StavInformacii;
end;


procedure ImputDatum;
var St, PomStr: string; PomWord: word; Code: integer;
label 1,2,3;
begin
  with CasVyletu do
    begin
      Hlaska('Napis den [1..31], len cislice ENTER - koniec,   ESC - zrusit');
      1:
      StavInformacii;
      Str(Den, PomStr);
      St := CitajText2(810, 30, 253, PomStr);
      if St = 'ESC' then Hlaska('ESC - prerusenie')
       else
        begin
          Val(St, PomWord, Code);
          if (Code <> 0) or (Je(1, PomWord, 31) = FALSE)
          then
            begin
              Hlaska('CHYBA - je treba vlozit len cislice [1..31] a nie ' + St);
              Goto 1;
            end
           else
            begin
              Den := PomWord;
              Hlaska('OK - vlozeny den: ' + St);
              Saved := FALSE;
            end;
        end;
      Hlaska('Napis mesiac [1..12], len cislice ENTER - koniec,   ESC - zrusit');
      2:
      StavInformacii;
      Str(Mesiac, PomStr);
      St := CitajText2(810, 30, 253, PomStr);
      if St = 'ESC' then Hlaska('ESC - prerusenie')
       else
        begin
          Val(St, PomWord, Code);
          if (Code <> 0) or (Je(1, PomWord, 12) = FALSE)
          then
            begin
              Hlaska('CHYBA - je treba vlozit len cislice [1..12] a nie ' + St);
              Goto 2;
            end
           else
            begin
              Mesiac := PomWord;
              Hlaska('OK - vlozeny mesiac: ' + St);
              Saved := FALSE;
            end;
        end;
      Hlaska('Napis rok [1980..2200], len cislice ENTER - koniec,   ESC - zrusit');
      3:
      StavInformacii;
      Str(Rok, PomStr);
      St := CitajText2(810, 30, 253, PomStr);
      if St = 'ESC' then Hlaska('ESC - prerusenie')
       else
        begin
          Val(St, PomWord, Code);
          if (Code <> 0) or (Je(1980, PomWord, 2200) = FALSE)
          then
            begin
              Hlaska('CHYBA - je treba vlozit len cislice [1980..2200] a nie ' + St);
              Goto 3;
            end
           else
            begin
              Rok := PomWord;
              Hlaska('OK - vlozeny rok: ' + St);
              Saved := FALSE;
            end;
        end;
      StavInformacii;
    end;
end;

procedure Uvod;
var Pocet: byte;
   Search: searchrec;
 F_NameList: array[1..30] of string[12];
      Pol: array[1..30] of string[100];
  PomStr,St: string;
        X: _X;
        Y: _Y;
        I: byte;
       Ch: char;
    Subor: file of Char;
label Opak;
begin
  {-- obrazovka --}
  SetTextStyle(3, 0, 10);
  SetColor(58);
  TextDoStredu(360, 'Editor Vyletov');
  SetTextStyle(2, 0, 10);
  SetColor(215);
  TextDoStredu(500, ProgDescrib);
  SetTextStyle(2, 0, 7);
  TextDoStredu(540, Autor);
  SetColor(215);
  SetTextStyle(0, 0, 1);
  OutTextXY(0, 750, Owner);
  OutTextXY(MaxX - TextWidth(SerCislo) - 50, 750, 'S/N:' + SerCislo);
  Logo(900, 100);
  Stempel(900, 150);
  SetTextStyle(0, 0, 1);
  {new OR load}
  OPAK:
  Hlaska('Ak chces zacat s novym suborom, stlac N. Ak chces loadnut sejvnuty subor, stlac L.     [N - novy,  L - load]');
  repeat
    Ch := Upcase(ReadKey);
  until Ch in ['L', 'N', #27];
  if Ch = #27 then Abord('Prerusenie, lebo lenivy OR nerozhodny user')
   else if Ch = 'L' then
     begin
       LoadData;
       if F_Name = '' then
         begin
           Hlaska('Bud si stlacil ESC, alebo v adresary neexistuje ziadny subor na nacitanie...');
           Delay(2500);
           goto OPAK; {neuspech}
         end;
     end
    else {novy subor}
      begin
        F_Name := 'NONAME' + F_Ext;  {standartny subor}
        {-load list-}
        Pocet := 0;
        FindFirst('*.EXE', Archive + ReadOnly, Search);
          while DosError = 0 do
            begin
              Assign(Subor, Search.Name); {ci to je obrazok}
              Reset(Subor);
              Read(Subor, Ch);
              Read(Subor, Ch);
              Read(Subor, Ch);
              Close(Subor);
              if Ch = #255 then {hura!, je to obrazok}
                begin
                  Inc(Pocet);
                  st := LowStr(Search.Name);
                  while Length(St) < 12 do St := St + ' ';
                  PomStr := '';
                  PomStr := PomStr + St + '   ';
                  St := Velkost(Search.Size);
                  while Length(St) < 10 do St := ' ' + St;
                  PomStr := PomStr + St + '   ';
                  Pol[Pocet] := PomStr;
                  F_NameList[Pocet] := Search.Name;
                end;
              FindNext(Search);
           end;
        if Pocet = 0 then Abord('Ziadne obrazky - pozadia (*.exe) v adresary');
        Hlaska('Vyber si EXE subor, v ktorom je ulozeny obrazok 1024x768x256,' +
               ' tento obrazok bude na pozadi.   (ESC - ukoncenie programu)');
        X := 50;
        Y := 100;
        Vymaz(X - 50, Y - 50, MaxX - X, Y + 10 * Pocet + 50, 0);
        SetColor(255);
        for i := 1 to Pocet do OutTextXY(X, Y + 10 * (i - 1), Pol[i]);
        SetColor(253);
        OutTextXY(X, Y - 15, 'Meno obrazku     Velkost');
        I := 1;
        SetColor(157);
        OutTextXY(X - 24, Y + 10 * (i - 1), '-->' + Pol[i]);
        repeat
          Ch := Upcase(ReadKey);
          SetColor(0);
          OutTextXY(X - 24, Y + 10 * (i - 1), '-->');
          SetColor(255);
          OutTextXY(X, Y + 10 * (i - 1), Pol[i]);
          case Klavesa(Ch) of
            7,4: i := 1;
            1,6: i := Pocet;
            8: if i > 1 then Dec(i);
            2: if i < pocet then Inc(i);
          end;
          SetColor(157);
          OutTextXY(X - 24, Y + 10 * (i - 1), '-->' + Pol[i]);
          St := F_NameList[i];
          while Length(St) < 12 do St := St + ' ';
          Hlaska('Vyberas si ' + St + '?   ENTER - ano,   ESC - zrusit,   sipky - ina volba');
        until (Ch = #27) or (Ch = #13);
        if Ch = #27 then
          begin
            Abord('Prerusenie, lebo lenivy OR nerozhodny user');
          end;
        Pozadie := F_NameList[i];
        RedrawScreen;
      end;
   VlozKontrolneBody;
end;


procedure About_To_Quit;
begin
  Skoncit := TRUE;;
  if Saved = FALSE then
    begin
      Ci_Ulozit_Pracu;
    end
  else if Ci_Skoncit = FALSE then Skoncit := FALSE; {Neskoncit}
end;


procedure Klavesy;
var St: string;
begin
  Ch := Upcase(Readkey);
  case Ch of
     #0: begin {specialne znaky}
           Ch := (Readkey);  {tu nemuoze byt UpCase(Readkey) !!!!!!!}
                             {inak by ALT-1 az ALT-3 nefungovalo!!!!}
           case Ch of
             #59: Help;            {F1}
             #60: Ci_Ulozit_Pracu; {F2}
             #61: LoadData;        {F3}
             #62: NewData;         {F4}
             #64: QuickSave;       {F6}
             #68: About_To_Quit;  {F10}
             #45: About_To_Quit;  {ALT-X}
             #103: Skoncit := TRUE; {CTRL-F10 - QuickQuit}
             #83: Color := SavedColor[1];  {Del}
             #79: Color := SavedColor[2];  {End}
             #81: Color := SavedColor[3];  {PgDn}
           end;
           if Je(120, Ord(Ch), 129) then  {predvolene farby}
             begin
               SavedColor[Ord(Ch) - 119] := Color;
               Str(Ord(Ch) - 119, St);
               Hlaska('Bola ulozena aktualna farba do pozicie ' + St);
             end;
         end;
    '+': Inc(Speed, Speed div 10);
    '-': if Speed > 10 then Dec(Speed, Speed div 10);
    #13: NastavFarbu;
    #17: About_To_Quit;  {Ctrl-Q}
    #09: begin PaletaVisible := not PaletaVisible; RedrawScreen; end; {Tab}
    'U': begin LupaVisible := not LupaVisible; RedrawScreen; end; {Tab}
    'W': ImputPoznamku;
    'R': RedrawScreen;
    'Z': Play;
    'L': LoadData; {LOAD}
    'N': NewData;
    'H': Help;
    'S': Ci_Ulozit_Pracu;
    'K': ImputKilometre;
    'P': ImputPopis;
    'T': ImputText;
    'D': ImputDatum;
    ' ': begin
           Draw := not Draw;
           if Draw then Hlaska('Kreslenie - ZAPNUTE')
            else Hlaska('Kreslenie - vypnute');
           Delay(200);
         end;
  end;
  Kurzor;
  case Klavesa(Ch) of  {kurzorove_sypky.pohyb}
    8: Dec(Y, 20);
    2: Inc(Y, 20);
    4: Dec(X, 20);
    6: Inc(X, 20);
  end;
  if Je(48, Ord(Ch), 57) then
    begin
      Str(Ord(Ch) - 48, St);
      Hlaska('Bola vyvolana farba z pozocie ' + St);
      if Ord(Ch) = 48 then Color := SavedColor[10]
       else Color := SavedColor[Ord(Ch) - 48];
    end;
  FarebnaPlocha;
  Stav;
  MouseInit(0, 0, MaxX, MaxY, Speed, Speed);
  MousePos(X, Y);
  while Keypressed do readkey;
end;


procedure TlacitkaMysi;
begin
  if Tlac = 1 then
    begin
      Draw := not Draw;
      if Draw then Hlaska('Kreslenie - ZAPNUTE')
       else Hlaska('Kreslenie - vypnute');
      repeat until MouseB = 0;
      Kurzor;
    end;
  if Tlac = 2 then
    begin
      Hlaska('Mys si posun na lubovolne miesto, potom stlac prave tlacitko...');
      repeat until MouseB = 0;
      repeat until MouseB = 2;
      repeat until MouseB = 0;
      MousePos(X, Y);
      VyHlaska;
    end;
end;

procedure InitSVGA1024_256;
var a,b:integer;
begin
  A:=InstallUserDriver('SVGA256', nil);
  B := 4;  {1024*768}
  InitGraph(A, B, '');
end;

procedure Instal_Mys;
begin
  Mouseinstall;
  MouseInit(0, 0, MaxX, MaxY, Speed, Speed);
  MouseCursor(1);
  MousePos(X, Y);
end;


procedure SetMyPalette;
var RGB_f: file of RGBlist;
    RGB: RGBlist;

begin
  {----- toto je na zapisanie PALety}
  {fgetcolors(rgb);
  assign(rgb_f, 'VYLED.PAL');
  rewrite(rgb_f);
  write(rgb_f, rgb);
  close(rgb_f);}

  {----- toto je citanie palety}
  Assign(RGB_f, 'VYLED.PAL');
  Reset(RGB_f);
  Read(RGB_f, RGB);
  Close(RGB_f);
  fSetColors(RGB);

end;

procedure Skontroluj(Co: string);
begin
  Write(' - ' + Co + '...');
  if FileExist(Co) then Writeln('OK!')
   else
     begin
       Writeln('?');
       Writeln(' --- Chyba subor ' + Co + ', dalej cesta nemozna');
       Halt(0);
     end;
end;


procedure VlastnyProgram;
var P1, P2, P3, P4: string[12];
begin
   ProgDescrib := 'VYLED 0.1 beta testovacia verzia';
   Autor := 'Marek Laco, januar/februar 1997 Bratislava';
   SerCislo := '0000000001';
   Owner := 'volne siritelne';
   P1 := 'VYLED.EXE';
   P2 := 'VYLED.PAL';
   P3 := 'VYLED_A.DAT';
   P4 := 'VYLED_B.DAT';

   Writeln;
   Writeln(ProgDescrib);
   Writeln(Autor);
   Writeln('Seriove cislo: ' + SerCislo);
   Writeln;
   Writeln('kontrolujem sucasti...');

   Skontroluj(P1);
   Skontroluj(P2);
   Skontroluj(P3);
   Skontroluj(P4);

   InitSVGA1024_256;
   SetMyPalette;

   ZiadneCHR;

   Prog_F_Name := 'VYLED.EXE'; {standartny nazov}
   F_Ext := '.TRP';  {standartna pripona}
   F_Name := '';
   Pozadie := ''; {standartne pozadie - exe subor 1024x768x256}

   Color := 255;
   CColor := Color;
   MaxX := GetMaxX;
   MaxY := GetMaxY;
   Speed := 30;

   PomX := 50;
   PomY := 50;

   X := MaxX div 2;
   Y := MaxY div 2;
   OldX := X;
   OldY := Y;

   Draw := FALSE;
   Saved := TRUE;
   Skoncit := FALSE;
   BoloShift := FALSE;
   LupaVisible := TRUE;
   PaletaVisible := TRUE;

   Ch := #0;
   for I := 1 to 10 do SavedColor[i] := 0;

   PodSize := 30; {pre pozadie}
   Size := ImageSize(X, Y, X + PodSize, Y + PodSize);
   GetMem(Podlozka, Size);


   Nuluj_Vsetky_Data;
   Instal_Mys;
   Uvod;
   {RedrawScreen; {poprve'}
   SkontrolujKontrolneBody; {ci sa nacital obrazok na obrazovku}
   SavePoz;
   NastavFarbu;
   Hlaska('Vytaj pri praci s Editorom Vyletov.  (haha)');
   Kurzor;

   repeat
     if keypressed then Klavesy;
     Tlac := MouseB;
     if SHIFT or ALT or CTRL then  {skoky misy}
       begin
         if ALT = FALSE then X := (MouseX div 10) * 10;
         if CTRL = FALSE then Y := (MouseY div 10) * 10;
         BoloShift := TRUE;
       end
      else
       begin
         if BoloShift then MousePos(X, Y);  {aby sa upravil kurzor}
         X := MouseX;
         Y := MouseY;
         BoloShift := FALSE;
       end;
     Skontoluj_Ci_Mys_nema_Vela;
     if (X <> OldX) or (Y <> OldY) or (Tlac <> 0) then
       begin
          LoadPoz;
          DrawCiaru;
          SavePoz;
          Kurzor;
          Lupa;
          if Draw then
            begin
              Saved := FALSE;
              Inc(T_Cislo);
                with Trasa[T_Cislo] do
                  begin
                    X1 := OldX;
                    Y1 := OldY;
                    X2 := X;
                    Y2 := Y;
                    Farba := Color;
                  end;
             end;
          OldX := X;
          OldY := Y;
          CColor := GetPixel(X, Y);
          TlacitkaMysi;
          Stav;
       end;
   until Skoncit;
   CloseGraph;
   Informacie_Na_Dobru_Noc;
end;

begin
  VlastnyProgram;
end.
